hdu 3698 Let the light guide us(线段树优化&简单DP)

Let the light guide us

Time Limit: 5000/2000 MS (Java/Others)    Memory Limit: 62768/32768 K (Java/Others)
Total Submission(s): 677    Accepted Submission(s): 226


Problem Description
Plain of despair was once an ancient battlefield where those brave spirits had rested in peace for thousands of years. Actually no one dare step into this sacred land until the rumor that “there is a huge gold mine underneath the plain” started to spread.

Recently an accident destroyed the eternal tranquility. Some greedy fools tried using powerful bombs to find the hidden treasure. Of course they failed and such behavior enraged those spirits--the consequence is that all the human villages nearby are haunted by ghosts.

In order to stop those ghosts as soon as possible, Panda the Archmage and Facer the great architect figure out a nice plan. Since the plain can be represented as grids of N rows and M columns, the plan is that we choose ONLY ONE cell in EACH ROW to build a magic tower so that each tower can use holy light to protect the entire ROW, and finally the whole plain can be covered and all spirits can rest in peace again. It will cost different time to build up a magic tower in different cells. The target is to minimize the total time of building all N towers, one in each row.

“Ah, we might have some difficulties.” said Panda, “In order to control the towers correctly, we must guarantee that every two towers in two consecutive rows share a common magic area.”

“What?”

“Specifically, if we build a tower in cell (i,j) and another tower in cell (i+1,k), then we shall have |j-k|≤f(i,j)+f(i+1,k). Here, f(i,j) means the scale of magic flow in cell (i,j).”

“How?”

“Ur, I forgot that you cannot sense the magic power. Here is a map which shows the scale of magic flows in each cell. And remember that the constraint holds for every two consecutive rows.”

“Understood.”

“Excellent! Let’s get started!”

Would you mind helping them?
 

Input
There are multiple test cases.

Each test case starts with a line containing 2 integers N and M (2<=N<=100,1<=M<=5000), representing that the plain consists N rows and M columns.

The following N lines contain M integers each, forming a matrix T of N×M. The j-th element in row i (Tij) represents the time cost of building a magic tower in cell (i, j). (0<=Tij<=100000)

The following N lines contain M integers each, forming a matrix F of N×M. The j-th element in row i (Fij) represents the scale of magic flows in cell (i, j). (0<=Fij<=100000)

For each test case, there is always a solution satisfying the constraints.

The input ends with a test case of N=0 and M=0.
 

Output
For each test case, output a line with a single integer, which is the minimum time cost to finish all magic towers.
 

Sample Input
  
  
3 5 9 5 3 8 7 8 2 6 8 9 1 9 7 8 6 0 1 0 1 2 1 0 2 1 1 0 2 1 0 2 0 0
 

Sample Output
  
  
10
 

Source
 

Recommend
chenyongfu
 

题意:

要在N*M(n<=100.m<=5000)的矩形区域的每行的一个位置建灯塔。而在第i行的j列建塔要花费时间ti[i][j].建塔还必须满足一个条件。

如果本行在j列建塔。下行在k列建塔。那么必须满足|j-k|<=f[i][j]+f[i+1][k]。

f[i][j]由题目给出。

问每行建完塔花费的最小时间。

思路:

很容易想到一个动规方程。dp[i][j]=min(dp[i][j],dp[i-1][k]+ti[i][j])。dp[i][j]代表前面i-1行建好塔。第i行在j列建塔的最小花费。

可问题又来了。这个k怎么确定。。。。。

如果暴力枚举的话时间复杂度为O(n*m*m)。目测最好n,m取最大的时候大于9秒吧。这还是单组数据。。。

所以不得不找其它办法优化下。

这个估计就要点思维了。我也是看了别人的转化才恍然大悟的。

我们去掉绝对值可以得到两个方程。

j-f[i][j]<=k+f[i+1][k]。 j>=k。

k-f[i+1][k]<=j+f[i][j]。 j<k。

可以发现k的取值范围即为区间[j-f[i][j],j+f[i][j]]和[k-f[i+1][k],k+f[i+1][k]]相交的部分。

所以思路就清晰了。要求dp[i][j]只需要知道上一行和[j-f[i][j],j+f[i][j]]相交部分的最小值就可以了。

而这个值可以用线段树维护。时间复杂度降到了。O(n*m*log(m))这下就没问题了。

详细见代码:

#include<algorithm>
#include<iostream>
#include<sstream>
#include<string.h>
#include<stdio.h>
#include<math.h>
#include<vector>
#include<string>
#include<queue>
#include<map>
using namespace std;
const int INF=0x3f3f3f3f;
const int maxn=150;
const int maxm=5010;
int ti[maxn][maxm],f[maxn][maxm],minv[maxm<<2],lazy[maxm<<2];
int dp[maxm],n,m;
void btree(int L,int R,int k)
{
    int ls,rs,mid;

    minv[k]=lazy[k]=INF;
    if(L==R)
        return ;
    ls=k<<1;
    rs=ls|1;
    mid=(L+R)>>1;
    btree(L,mid,ls);
    btree(mid+1,R,rs);
}
void pushdown(int k,int ls,int rs)
{
    minv[ls]=min(minv[ls],lazy[k]);
    minv[rs]=min(minv[rs],lazy[k]);
    lazy[ls]=min(lazy[ls],lazy[k]);
    lazy[rs]=min(lazy[rs],lazy[k]);
    lazy[k]=INF;
}
void update(int L,int R,int l,int r,int k,int v)
{
    int ls,rs,mid;
    if(L==l&&R==r)
    {
        minv[k]=min(minv[k],v);
        lazy[k]=min(lazy[k],v);
        return;
    }
    ls=k<<1;
    rs=ls|1;
    mid=(L+R)>>1;
    if(lazy[k]!=INF)
        pushdown(k,ls,rs);
    if(l>mid)
        update(mid+1,R,l,r,rs,v);
    else if(r<=mid)
        update(L,mid,l,r,ls,v);
    else
    {
        update(L,mid,l,mid,ls,v);
        update(mid+1,R,mid+1,r,rs,v);
    }
    minv[k]=min(minv[ls],minv[rs]);
}
int qu(int L,int R,int l,int r,int k)
{
    int ls,rs,mid;
    if(L==l&&R==r)
        return minv[k];
    ls=k<<1;
    rs=ls|1;
    mid=(L+R)>>1;
    if(lazy[k]!=INF)
        pushdown(k,ls,rs);
    if(l>mid)
        return qu(mid+1,R,l,r,rs);
    else if(r<=mid)
        return qu(L,mid,l,r,ls);
    else
        return min(qu(L,mid,l,mid,ls),qu(mid+1,R,mid+1,r,rs));

}
int main()
{
    int i,j,l,r,ans;

    while(scanf("%d%d",&n,&m),n||m)
    {
        for(i=1;i<=n;i++)
            for(j=1;j<=m;j++)
                scanf("%d",&ti[i][j]);
        for(i=1;i<=n;i++)
            for(j=1;j<=m;j++)
                scanf("%d",&f[i][j]);
        for(i=1;i<=m;i++)
            dp[i]=ti[1][i];
        for(i=2;i<=n;i++)
        {
            btree(1,m,1);
            for(j=1;j<=m;j++)
            {
                l=max(j-f[i-1][j],1);
                r=min(j+f[i-1][j],m);
                update(1,m,l,r,1,dp[j]);
            }
            for(j=1;j<=m;j++)
            {
                l=max(j-f[i][j],1);
                r=min(j+f[i][j],m);
                dp[j]=qu(1,m,l,r,1)+ti[i][j];
            }
        }
        ans=INF;
        for(i=1;i<=m;i++)
            ans=min(ans,dp[i]);
        printf("%d\n",ans);
    }
    return 0;
}


  • 1
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值